package cz.upol.swing2;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.AbstractListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;

public class CustomModelListExample extends JFrame {
	
	private static final long serialVersionUID = 7072358438662567666L;
	private JList<Integer> mainList;
	private JButton btnAdd;
	private JPanel mainPanel;
	
	private EvenIntsListModel listModel;

	public CustomModelListExample()  {
		super();
		
		this.setTitle("Custom Model");
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setPreferredSize(new Dimension(400, 400));
		
		listModel = new EvenIntsListModel(10);
		mainList = new JList<>(listModel);
		
		btnAdd = new JButton("add");
		btnAdd.addActionListener(e -> {
			int newCount = listModel.getN() + 1;
			listModel.setN(newCount);	
		});
		
		mainPanel = new JPanel(new BorderLayout());
		mainPanel.add(mainList, BorderLayout.CENTER);
		mainPanel.add(btnAdd, BorderLayout.SOUTH);
		
		this.setContentPane(mainPanel);
		this.pack();
	}
	
	private static class EvenIntsListModel extends AbstractListModel<Integer> {

		private static final long serialVersionUID = -1733824189990842822L;
		
		private int n;
		
		public EvenIntsListModel(int n) {
			this.n = n;
		}

		@Override
		public int getSize() {
			return n;
		}

		@Override
		public Integer getElementAt(int index) {
			return (index + 1) * 2;
		}

		public int getN() {
			return n;
		}

		public void setN(int n) {
			this.n = n;
			fireIntervalAdded(this, 0, n);
		}
	}
}
