package cz.upol.swing2;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;

public class ListAndDialogExample extends JFrame {

	private static final long serialVersionUID = -6990968542961079817L;
	
	private JList<String> mainList;
	private JButton btnAdd;
	private JPanel mainPanel;
	private DefaultListModel<String> listModel;

	private List<String> items = new ArrayList<String>();

	public ListAndDialogExample()  {
		super();
		
		items.add("Foo");
		items.add("Bar");
		
		this.setTitle("Lists & Dialogs");
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setPreferredSize(new Dimension(400, 400));

		// vytvori seznam s pevne danym listem polozek
		// mainList = new JList(new String [] {"Foo", "Bar" });
		
		// vytvori seznam, ktery je zpracovava data z nejakeho konkretniho datoveho modelu
		// nejdriv vytvori model, pak do nej vlozi prvek a priradi jej seznamu
		listModel = new DefaultListModel<>();
		listModel.addElement("Foo");
		mainList = new JList<>(listModel);
		
		btnAdd = new JButton("add");
		btnAdd.addActionListener(new AddAction(this));
		
		mainPanel = new JPanel(new BorderLayout());
		mainPanel.add(mainList, BorderLayout.CENTER);
		mainPanel.add(btnAdd, BorderLayout.SOUTH);
		
		this.setContentPane(mainPanel);
		this.pack();
	}
	/**
	 * Udalost, ktera zobrazi formular
	 */
	private class AddAction implements ActionListener {

		private JFrame parentFrame;
		public AddAction(JFrame frame) {
			this.parentFrame = frame;
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			DialogExample dlg = new DialogExample(parentFrame); // vytvori dialog a udava, ktery formular je nadrazeny
			dlg.setModal(true);						// modalita !!!
			dlg.setVisible(true);					// ceka dokud nebude uzavren formular 
			if (dlg.getResult() != null)			// precte hodnotu
				listModel.addElement(dlg.getResult());
			
			dlg.dispose();
		}
	}
}
